// TYPE: C
// PRJ: JCL
// PGM: Jiro_Array.c
// VER: 1.00
// USES: GCC
// CREATE: 2007/04/02( tamura )
/////////////////////////////////////////////////////
// malloc
// MFCvWFNggpꍇ́AL̃RgOB
#include "stdafx.h"

#include "Jiro_Array.h"
#include <stdlib.h>
#include <string.h>


//============================================================
// 萔
//============================================================
#define kDefaultInitRecNum   20
#define kDefaultExpandRecNum 20

//============================================================
// ֐̃vg^Cv錾
//============================================================
static bool IsValidIndex( JIRO_ARY_HDL inAryHdl, long inIndex );
static void* GetDataPosByIndex( const void* inRecPtr, long inRecSize, long inIndex );

//============================================================
// ֐
//============================================================
//--------------------------------------------------
// ֐ : Jiro_Ary_Init
// @\ : JiroAry̏
//--------------------------------------------------
JIRO_ARY_HDL Jiro_Ary_Init( long inRecSize, long inInitRecNum, long inExpandRecNum )
{
	JIRO_ARY* aryPtr;
	long initRecNum;
	long expandRecNum;

	// R[h
	if( 0 < inInitRecNum )
	{
		// ̒lg
		initRecNum = inInitRecNum;
	}
	else
	{
		// ftHg̒lg
		initRecNum = kDefaultInitRecNum;
	}

	// R[h
	if( 0 < inExpandRecNum )
	{
		// ̒lg
		expandRecNum = inExpandRecNum;
	}
	else
	{
		// ftHg̒lg
		expandRecNum = kDefaultExpandRecNum;
	}

	// zǗe[ům
	aryPtr = ( JIRO_ARY* )malloc( sizeof( JIRO_ARY ) );
	if( aryPtr == NULL )
	{  // mۂłȂ
		return NULL;
	}

	// 
	aryPtr->recPtr = NULL;
	aryPtr->recNum = 0;
	aryPtr->dataNum = 0;
	aryPtr->recSize = inRecSize;
	aryPtr->initRecNum = initRecNum;
	aryPtr->expandRecNum = expandRecNum;

	return aryPtr;
}

//--------------------------------------------------
// ֐ : Jiro_Ary_GetSize
// @\ : z̃R[h擾
//--------------------------------------------------
long Jiro_Ary_GetSize( JIRO_ARY_HDL inAryHdl )
{
	return inAryHdl->dataNum;
}

//--------------------------------------------------
// ֐ : Jiro_Ary_Insert
// @\ : zɃR[h}
// Ԓl : 0  : 
//        -1 : G[isj
//--------------------------------------------------
int Jiro_Ary_Insert( JIRO_ARY_HDL inAryHdl, long inIndex, const void * inAddRecPtr )
{
	void* newBufPtr;
	long newBufSize;
	long newRecNum;
	long dataIndex;
	void* newPos;
	void* oldPos;
	long shiftDataSize;
	void* newDataPos;

	// R[hobt@܂mۂĂȂH
	if( inAryHdl->recPtr == NULL )
	{
		// VR[h
		newRecNum = inAryHdl->initRecNum;

		// Vobt@TCY
		newBufSize = newRecNum * inAryHdl->recSize;

		// ̈m
		newBufPtr = malloc( newBufSize );
		if( newBufPtr == NULL )
		{ // mێs
			inAryHdl->recPtr  = NULL;
			inAryHdl->recNum  = 0;
			inAryHdl->dataNum = 0;
			return -1;  // G[
		}

		// zǗe[uXV
		inAryHdl->recPtr  = newBufPtr;
		inAryHdl->recNum  = newRecNum;
		inAryHdl->dataNum = 0;
	}

	// 󂫂ȂH
	if( inAryHdl->recNum <= inAryHdl->dataNum )
	{
		// VR[h
		newRecNum = inAryHdl->recNum + inAryHdl->expandRecNum;

		// Vobt@TCY
		newBufSize = newRecNum * inAryHdl->recSize;

		// obt@g
		newBufPtr = realloc( inAryHdl->recPtr, newBufSize );
		if( newBufPtr == NULL )
		{ // głȂ
			return -1;  // G[
		}

		// zǗe[uXV
		inAryHdl->recPtr = newBufPtr;
		inAryHdl->recNum = newRecNum;
	}

	// R[h̑}ʒu␳
	dataIndex = inIndex;
	if( dataIndex < 0 )
	{
		dataIndex = 0;
	}
	if( inAryHdl->dataNum < dataIndex )
	{
		dataIndex = inAryHdl->dataNum;
	}

	// }ʒuȍ~̃R[h炷
	if( dataIndex < inAryHdl->dataNum )
	{ // 炷Kv
		newPos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, dataIndex + 1 );  // ړ̈ʒu
		oldPos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, dataIndex );      // ړÖʒu
		shiftDataSize = inAryHdl->recSize * ( inAryHdl->dataNum - dataIndex );  // 炷f[^̃TCY
		memmove( newPos, oldPos, shiftDataSize );  // ̈悪dȂĂ\̂ړ
	}

	// f[^}
	newDataPos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, dataIndex );
	if( inAddRecPtr != NULL )
	{
		// f[^
		memcpy( newDataPos, inAddRecPtr, inAryHdl->recSize );
	}
	else
	{
		// 0NAꂽf[^
		memset( newDataPos, 0, inAryHdl->recSize );
	}

	// f[^XV
	inAryHdl->dataNum = inAryHdl->dataNum + 1;

	return 0;  // f[^̑}ɐ
}

//--------------------------------------------------
// ֐ : Jiro_Ary_Add
// @\ : zɃR[hǉ
//--------------------------------------------------
int Jiro_Ary_Add( JIRO_ARY_HDL inAryHdl, const void* inAddRecPtr )
{
	int rc;

	// f[^ɒǉ
	rc = Jiro_Ary_Insert( inAryHdl, inAryHdl->dataNum + 1, inAddRecPtr );

	return rc;
}

//--------------------------------------------------
// ֐ : Jiro_Ary_Free
// @\ : 
//--------------------------------------------------
void Jiro_Ary_Free( JIRO_ARY_HDL inAryHdl )
{
	// NULL`FbN
	if( inAryHdl == NULL )
	{ // zǗe[um
		return;
	}

	// f[^̈mۂĂ
	if( inAryHdl->recPtr != NULL )
	{
		free( inAryHdl->recPtr );
	}

	// zǗe[u
	memset( inAryHdl, 0, sizeof( JIRO_ARY ) );  // Ô߃NA
	free( inAryHdl );
}

//--------------------------------------------------
// ֐ : Jiro_Ary_Update
// @\ : R[h̒lXV
//--------------------------------------------------
void Jiro_Ary_Update( JIRO_ARY_HDL inAryHdl, long inIndex, const void* inRecPtr )
{
	void* dataPos;

	// NULL`FbN
	if( inAryHdl == NULL )
	{
	     return;
	}
	if( inAryHdl->recPtr == NULL )
	{
	     return;
	}

	// CfbNX`FbN
	if( IsValidIndex( inAryHdl, inIndex ) == false )
	{
	     return;
	}

	// lXV
	dataPos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, inIndex );
	memcpy( dataPos, inRecPtr, inAryHdl->recSize );
}

//--------------------------------------------------
// ֐ : IsValidIndex
// @\ : ݂̔zɑ΂Ďgp\ȃCfbNXǂ
// Ԓl : true  : gp\(͈͓)
//        false : gps(͈͊O)
//--------------------------------------------------
static bool IsValidIndex( JIRO_ARY_HDL inAryHdl, long inIndex )
{
     // 0ƃ_
     if( inIndex < 0 )
     {
	  return false;
     }

     // f[^ȏゾƃ_
     if( inAryHdl->dataNum <= inIndex )
     {
	  return false;
     }

     return true;
}

//--------------------------------------------------
// ֐ : GetDataPosByIndex
// @\ : w肳ꂽCfbNXɑΉf[^̈ʒu
//--------------------------------------------------
static void* GetDataPosByIndex( const void* inRecPtr, long inRecSize, long inIndex )
{
	char* basePos;
	char* dataPos;

	// ʒu
	basePos = (char*)inRecPtr;

	// f[^ʒu
	dataPos = basePos + ( inRecSize * inIndex );

	return (void*)dataPos;
}

//--------------------------------------------------
// ֐ : Jiro_Ary_Remove
// @\ : z̎w肳ꂽCfbNX̃R[h폜
//  : w肳ꂽCfbNX̃f[^A1Oɂ炷
//--------------------------------------------------
void Jiro_Ary_Remove( JIRO_ARY_HDL inAryHdl, long inRemoveIndex )
{
	void* specifiedDataPos;
	void* nextDataPos;
	long moveDataSize;

	// NULL`FbN
	if( inAryHdl == NULL )
	{
		return;
	}
	if( inAryHdl->recPtr == NULL )
	{
		return;
	}

	// CfbNX`FbN
	if( IsValidIndex( inAryHdl, inRemoveIndex ) == false )
	{
		return;
	}

	// 炷f[^̃TCY
	moveDataSize = inAryHdl->recSize * ( inAryHdl->dataNum - inRemoveIndex - 1 );

	// 炷Kv邩
	if( moveDataSize <= 0 )
	{
		inAryHdl->dataNum = inAryHdl->dataNum - 1;	// f[^XV
		return;
	}

	// w肳ꂽf[^̈ʒu
	specifiedDataPos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, inRemoveIndex );

	// w肳ꂽf[^̎̃f[^̈ʒu
	nextDataPos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, inRemoveIndex + 1 );

	// w肳ꂽf[^̃f[^Aw肳ꂽf[^̈ʒuɂ炷
	memmove( specifiedDataPos, nextDataPos, moveDataSize );  // memmoveł͗̈悪dȂĂĂ悢B
	inAryHdl->dataNum = inAryHdl->dataNum - 1;	// f[^XV
}

//--------------------------------------------------
// ֐ : Jiro_Ary_RemoveAll
// @\ : ẑׂẴR[h폜
//--------------------------------------------------
void Jiro_Ary_RemoveAll( JIRO_ARY_HDL inAryHdl )
{
     // zǗe[uXV
     inAryHdl->recNum = 0;
     inAryHdl->dataNum = 0;

     // f[^̈
	 if( inAryHdl->recPtr != NULL )
	 {
		free( inAryHdl->recPtr );
		inAryHdl->recPtr = NULL;
	 }
}

//--------------------------------------------------
// ֐ : Jiro_Ary_Swap
// @\ : z̃R[h̏Ԃւ
// add tamura 081128
//--------------------------------------------------
void Jiro_Ary_Swap( JIRO_ARY_HDL inAryHdl, long inIndex1, long inIndex2 )
{
	void* data1Pos;
	void* data2Pos;
	void* tempData;

	// NULL`FbN
	if( inAryHdl == NULL )
	{
		return;
	}
	if( inAryHdl->recPtr == NULL )
	{
		return;
	}

	// CfbNX`FbN
	if( IsValidIndex( inAryHdl, inIndex1 ) == false )
	{
		return;
	}
	if( IsValidIndex( inAryHdl, inIndex2 ) == false )
	{
		return;
	}

	// f[^̈ʒu擾
	data1Pos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, inIndex1 );
	data2Pos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, inIndex2 );

	// f[^̈ꎞu擾
	tempData = malloc( inAryHdl->recSize );
	if( tempData == NULL )
	{
		return;
	}

	// f[^ւ
	memcpy(  tempData, data1Pos, inAryHdl->recSize );
	memmove( data1Pos, data2Pos, inAryHdl->recSize );  // memo tamura 081205 memmove Ȃ̂ inIndex1 == inIndex2 ̏ꍇ̂߁H
	memcpy(  data2Pos, tempData, inAryHdl->recSize );

	// ꎞu
	free( tempData );
}

//--------------------------------------------------
// ֐ : Jiro_Ary_QuickSort
// @\ : zNCbN\[gŃ\[g
// add tamura 081128
//--------------------------------------------------
void Jiro_Ary_QuickSort( JIRO_ARY_HDL inAryHdl, QUICKSORT_COMPARE_FUNC_PTR inCompareFuncPtr )
{
	// NULL`FbN
	if( inAryHdl == NULL )
	{
		return;
	}
	if( inAryHdl->recPtr == NULL )
	{
		return;
	}

	// \[gf[^邩
	if( inAryHdl->dataNum < 2 )
	{
		return;  // \[g̕KvȂ
	}

	// NCbN\[g
	qsort( inAryHdl->recPtr, inAryHdl->dataNum, inAryHdl->recSize, inCompareFuncPtr );
}

//--------------------------------------------------
// ֐ : Jiro_Ary_Lock
// @\ : R[hobt@bN
//  : malloc łł̓bN̕KvȂ̂ŁAȂ
//        GlobalAlloc łł́AK outSaveLock  false ԂĂ
// add tamura 081204
//--------------------------------------------------
void Jiro_Ary_Lock( JIRO_ARY_HDL inAryHdl, bool * outSaveLock )
{
	// GlobalAlloc łƓɂȂ悤
	*outSaveLock = false;
}

//--------------------------------------------------
// ֐ : Jiro_Ary_Unlock
// @\ : R[hobt@AbN
//  : malloc łł̓bN̕KvȂ̂ŁAȂ
// add tamura 081204
//--------------------------------------------------
void Jiro_Ary_Unlock( JIRO_ARY_HDL inAryHdl, bool inSaveLock )
{
}

//--------------------------------------------------
// ֐ : Jiro_Ary_GetData
// @\ : z̃R[h擾
//  : `FbNOɁAo͐0NAĂ
//--------------------------------------------------
void Jiro_Ary_GetData( JIRO_ARY_HDL inAryHdl, long inIndex, void* outRecPtr )
{
	void* dataPos;

	// o0NA
	memset( outRecPtr, 0, inAryHdl->recSize );

	if( inAryHdl->recPtr == NULL )
	{ // f[^܂Ȃ
		return;
	}
	if( IsValidIndex( inAryHdl, inIndex ) == false )
	{ // CfbNX͈͊O
		return;
	}

	// f[^ʒu
	dataPos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, inIndex );

	// f[^擾
	memcpy( outRecPtr, dataPos, inAryHdl->recSize );
}

//--------------------------------------------------
// ֐ : Jiro_Ary_GetDataPtr
// @\ : z̃R[hւ̃|C^擾
// add tamura 081204
//--------------------------------------------------
void* Jiro_Ary_GetDataPtr( JIRO_ARY_HDL inAryHdl, long inIndex )
{
	void* dataPos;

	if( inAryHdl->recPtr == NULL )
	{ // f[^܂Ȃ
		return NULL;
	}
	if( IsValidIndex( inAryHdl, inIndex ) == false )
	{ // CfbNX͈͊O
		return NULL;
	}

	// f[^ʒu
	dataPos = GetDataPosByIndex( inAryHdl->recPtr, inAryHdl->recSize, inIndex );

	return dataPos;
}


// ̊֐
/* //\************************************************************************* */
/* // ֐ */
/* //\************************************************************************* */
/* //----------------------------------------------------- */
/* // ֐F Jiro_Ary_SetSize */
/* // @\F z̃TCYύXBf[^ׂ͂0NA */
/* // ߂lFi0:A-1FsG[j */
/* //----------------------------------------------------- */
/* int Jiro_Ary_SetSize(JIRO_ARY_HDL inAryHdl, long inSize) */
/* { */
/* 	int		rc = 0; */
/* 	HGLOBAL	recHdl; */
/* 	JIRO_ARY *		aryPtr; */
	
/* //----------------------------------------------------- */
/* // ֐F Jiro_Ary_SeqSearch */
/* // @\F zV[PXT[` */
/* // ߒlF 0ȏiR[h̃CfbNXjA-1iYȂj */
/* //----------------------------------------------------- */
/* long Jiro_Ary_SeqSearch(JIRO_ARY_HDL inAryHdl, const void * key, bool (__cdecl *compare_proc)(const void * key, const void * recPtr)) */
/* { */
/* 	JIRO_ARY *		aryPtr; */
/* 	char *	recPtr; */
/* 	long	index, foundIndex; */
	
/* 	aryPtr = (JIRO_ARY *)GlobalLock(inAryHdl); */
/* 	if ((aryPtr->recHdl == NULL) || (aryPtr->dataNum <= 0)) */
/* 	{ */
/* 		foundIndex = -1; */
/* 	} */
/* 	else */
/* 	{ */
/* 		foundIndex = -1; */
/* 		recPtr = (char *)GlobalLock(aryPtr->recHdl); */
/* 		for (index = 0; (index < aryPtr->dataNum) && (foundIndex == -1); index++) */
/* 		{ */
/* 			if (compare_proc(key, recPtr + (index * aryPtr->recSize)) == TRUE)	// vH */
/* 			{ */
/* 				foundIndex = index; */
/* 			} */
/* 		} */
/* 		GlobalUnlock(aryPtr->recHdl); */
/* 	} */

/* 	GlobalUnlock(inAryHdl); */

/* 	return foundIndex; */
/* } */

/* //----------------------------------------------------- */
/* // ֐F Jiro_Ary_Copy */
/* // @\F zRs[ */
/* //----------------------------------------------------- */
/* /\* */
/* int Jiro_Ary_Copy(JIRO_ARY_HDL inDestAryHdl, JIRO_ARY_HDL inSrcAryHdl) */
/* { */
/* 	JIRO_ARY	workTbl; */
/* 	int			rc = 0; */
	
/* 	workTbl = (**inSrcAryHdl); */
/* 	if (workTbl.recHdl != NULL) */
/* 	{ */
/* 		osErr = HandToHand(&workTbl.recHdl); */
/* 		if (osErr != noErr) */
/* 			return osErr; */
/* 	} */

/* 	Jiro_Ary_RemoveAll(inDestAryHdl); */
	
/* 	(**inDestAryHdl) = workTbl; */
	
/* 	return osErr; */

/* } */
/* *\/ */

