// TYPE: C
// PRJ: JCL
// PGM: Jiro_Array
// VER: 1.00
// USES: GCC
// CREATE: 2007/04/02( tamura )
/////////////////////////////////////////////////////
// malloc

#ifndef __JIRO_ARRAY__
#define __JIRO_ARRAY__

#include "Jiro_Types.h"
#include "Jiro_Const.h"

#ifdef __cplusplus
extern "C" {
#endif

//============================================================
// \
//============================================================
// zǗe[u
typedef struct
{
  void* recPtr;       // f[^̈obt@ւ̃|C^
  long recNum;        // ̈mۍσR[h
  long dataNum;       // gpR[h
  long recSize;       // 1R[h̃TCY
  long initRecNum;    // R[h
  long expandRecNum;  // R[h
} JIRO_ARY;

//============================================================
// ^
//============================================================
typedef JIRO_ARY* JIRO_ARY_HDL;
typedef int( * QUICKSORT_COMPARE_FUNC_PTR )( const void *, const void * );


//============================================================
// ֐
//============================================================
//--------------------------------------------------
// ֐ : Jiro_Ary_Init
// @\ : Array Buffer 
//--------------------------------------------------
JIRO_ARY_HDL Jiro_Ary_Init( long inRecSize, long inInitRecNum, long inExpandRecNum );

//--------------------------------------------------
// ֐ : Jiro_Ary_GetSize
// @\ : z̃R[h擾
//--------------------------------------------------
long Jiro_Ary_GetSize( JIRO_ARY_HDL inAryHdl );

//--------------------------------------------------
// ֐ : Jiro_Ary_Insert
// @\ : zɃR[h}
//--------------------------------------------------
int Jiro_Ary_Insert( JIRO_ARY_HDL inAryHdl, long inIndex, const void * inAddRecPtr );

//--------------------------------------------------
// ֐ : Jiro_Ary_GetData
// @\ : z̃R[h擾
//  : `FbNOɁAo͐0NAĂ
//--------------------------------------------------
void Jiro_Ary_GetData( JIRO_ARY_HDL inAryHdl, long inIndex, void* outRecPtr );

//--------------------------------------------------
// ֐ : Jiro_Ary_Add
// @\ : zɃR[hǉ
//--------------------------------------------------
int Jiro_Ary_Add( JIRO_ARY_HDL inAryHdl, const void* inAddRecPtr );

//--------------------------------------------------
// ֐ : Jiro_Ary_Free
// @\ : 
//--------------------------------------------------
void Jiro_Ary_Free( JIRO_ARY_HDL inAryHdl );

//--------------------------------------------------
// ֐ : Jiro_Ary_Update
// @\ : R[h̒lXV
//--------------------------------------------------
void Jiro_Ary_Update( JIRO_ARY_HDL inAryHdl, long inIndex, const void* inRecPtr );

//--------------------------------------------------
// ֐ : Jiro_Ary_Remove
// @\ : z̎w肳ꂽCfbNX̃R[h폜
//  : w肳ꂽCfbNX̃f[^A1Oɂ炷
//--------------------------------------------------
void Jiro_Ary_Remove( JIRO_ARY_HDL inAryHdl, long inRemoveIndex );

//--------------------------------------------------
// ֐ : Jiro_Ary_RemoveAll
// @\ : ẑׂẴR[h폜
//--------------------------------------------------
void Jiro_Ary_RemoveAll( JIRO_ARY_HDL inAryHdl );

//--------------------------------------------------
// ֐ : Jiro_Ary_Swap
// @\ : z̃R[h̏Ԃւ
//--------------------------------------------------
void Jiro_Ary_Swap( JIRO_ARY_HDL inAryHdl, long inIndex1, long inIndex2 );

//--------------------------------------------------
// ֐ : Jiro_Ary_QuickSort
// @\ : zNCbN\[gŃ\[g
//--------------------------------------------------
void Jiro_Ary_QuickSort( JIRO_ARY_HDL inAryHdl, QUICKSORT_COMPARE_FUNC_PTR inCompareFuncPtr );

//--------------------------------------------------
// ֐ : Jiro_Ary_Lock
// @\ : R[hobt@bN
//  : malloc łł̓bN̕KvȂ̂ŁAȂ
//        GlobalAlloc łł́AK outSaveLock  false ԂĂ
//--------------------------------------------------
void Jiro_Ary_Lock( JIRO_ARY_HDL inAryHdl, bool * outSaveLock );

//--------------------------------------------------
// ֐ : Jiro_Ary_Unlock
// @\ : R[hobt@AbN
//  : malloc łł̓bN̕KvȂ̂ŁAȂ
//--------------------------------------------------
void Jiro_Ary_Unlock( JIRO_ARY_HDL inAryHdl, bool inSaveLock );

//--------------------------------------------------
// ֐ : Jiro_Ary_GetDataPtr
// @\ : z̃R[hւ̃|C^擾
// add tamura 081204
//--------------------------------------------------
void* Jiro_Ary_GetDataPtr( JIRO_ARY_HDL inAryHdl, long inIndex );

#ifdef __cplusplus
}
#endif

#endif // __JIRO_ARRAY__
