// TYPE: C
// PRJ: JCL
// PGM: Jiro_String
// VER: 3.00
// USES: CodeWarrior, Xcode, Visual C++ 6.0-10.0, JCL
// CREATE: 1999/02/21( Siratori )
// UPDATE: 1999/10/01( Siratori )
// UPDATE: 2003/04/09( tsunoda )
// UPDATE: 2005/03/15( hisa )
// UPDATE: 2007/02/20( hisa, igari )
// UPDATE: 2007/08/28( tamura )
// UPDATE: 2008/06/06( tamura, sugimoto )
// UPDATE: 2009/05/13( hisa )
// UPDATE: 2009/08/18( hisa )
// UPDATE: 2009/07/30( hisa )
// UPDATE: 2011/07/20( hisa )
// UPDATE: 2012/06/05( wat )
/////////////////////////////////////////////////////
// MFCvWFNggpꍇ́AL̃RgOB
#include "stdafx.h"

// ansi
#include <string.h>
#include <ctype.h>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>

// JCL
#include "Jiro_Const.h"
#include "Jiro_String.h"
#include "Jiro_File.h"

//*************************************************************************
// ֐̃vg^Cv錾
//*************************************************************************
static bool IsStartWithSplit( const char* inStr, const char* inSplitStrAry[], long inSplitStrCnt, long* outSpilitIndex );
static long GetEncoding( const char* inTextData, long inTextDataSize );
static long CheckSJIS( const char* inTextData, long inTextDataSize );
static long CheckEUC( const char* inTextData, long inTextDataSize );
static long CheckUTF8( const char* inTextData, long inTextDataSize );
static bool IsASCII( const char* inTextData, long inTextDataSize );
static bool IsISO2022JP( const char* inTextData, long inTextDataSize );

//*************************************************************************
// ֐
//*************************************************************************
//-------------------------------------------------------------
// ֐ : Jiro_Pstrcpy
// @\ : pXJRs[
//-------------------------------------------------------------
void Jiro_Pstrcpy( unsigned char* outDestStr, unsigned char* inSrcStr )
{
	short	len;
	
	if (!outDestStr || !inSrcStr)
	{
		return;
	}
	
	len = inSrcStr[0];
	memcpy( outDestStr, inSrcStr, len + 1 );
}

//-------------------------------------------------------------
// ֐ : Jiro_Pstrcat
// @\ : pXJA
//-------------------------------------------------------------
void Jiro_Pstrcat( unsigned char* ioStr, unsigned char* inAddStr )
{
	short	srcLen, addLen;
	
	if (!ioStr || !inAddStr )
	{
		return;
	}
	
	srcLen = ioStr[0];
	addLen = inAddStr[0];
	
	if (addLen + srcLen > kJIRO_UCHAR_MAX)
	{
		addLen = kJIRO_UCHAR_MAX - srcLen;
	}
	
	memcpy( &ioStr[srcLen + 1], &inAddStr[1] , addLen );
	ioStr[0] += ( (unsigned char)addLen );
}

//-------------------------------------------------------------
// ֐ : Jiro_Cstr2Pstr
// @\ : bpXJɕϊ
//-------------------------------------------------------------
void Jiro_Cstr2Pstr( unsigned char* outDestStr, const char* inSrcStr )
{
	long	len;
	
	if (!outDestStr || !inSrcStr)
	{
		return;
	}
	
	len = (long)strlen(inSrcStr);
	if (len > kJIRO_UCHAR_MAX)
	{
		len = kJIRO_UCHAR_MAX;
	}
	
	memcpy(&outDestStr[1], inSrcStr, len);
	outDestStr[0] = (unsigned char)len;
}

//-------------------------------------------------------------
// ֐ : Jiro_Pstr2Cstr
// @\ : pXJbɕϊ
//-------------------------------------------------------------
void Jiro_Pstr2Cstr( char* outDestStr, const unsigned char* inSrcStr )
{
	short	len;
	
	if (!outDestStr || !inSrcStr)
	{
		return;
	}
	
	len = inSrcStr[0];
	memcpy( outDestStr, &inSrcStr[1], len );
	outDestStr[len] = '\0';
}

//-------------------------------------------------------------
// ֐ : Jiro_CutStringLength
// @\ : 񒷂w肳ꂽŃJbg
//-------------------------------------------------------------
void Jiro_CutStringLength( char* ioStr, long inLength )
{
	short	attr;
	long	len;
	
	if (!ioStr)
	{
		return ;
	}
	
	len = (long)strlen( ioStr );
	if ( len < inLength )	// 񒷂𒴂H
	{
		return ;
	}
	
	if ( inLength <= 0 )			// OwH
	{
		ioStr[0] = '\0';
		return ;
	}
	
	attr = Jiro_GetCharAttr((unsigned char*) ioStr, inLength - 1);	// 擾
	if ((attr == 0) || (attr == 2))		// p܂͑Sp̂QoCgځH
	{
		ioStr[inLength] = '\0';
	}
	else
	{
		ioStr[inLength - 1] = '\0';
	}
}

//-------------------------------------------------------------
// ֐ : Jiro_GetCharAttr
// @\ : ̑擾
// ߂lF 0FpAPFSp̂PoCgځAQFSp̂QoCg
// 1999.10.1-1 add
//-------------------------------------------------------------
short Jiro_GetCharAttr( unsigned char* ioStr, long nOff )
{
	bool	bKanji = false; //  mod takaesu 070730
	short	nAtr;
	long	i;
	
	i = 0;
	while (i <= nOff)
	{
		if (Jiro_IsZenkaku1(ioStr[i]))
		{
			bKanji = true;
			i += 2;
		}
		else
		{
			bKanji = false;
			i++;
		}
	}
	if (i >= (nOff + 2))
	{
		nAtr = 1;
	}
	else
	{
		if (bKanji)
		{
			nAtr = 2;
		}
		else
		{
			nAtr = 0;
		}
	}
	return (nAtr);
}

//-------------------------------------------------------------
// ֐ : Jiro_IsZenkaku1
// @\ : Sp̂PoCgځH
//-------------------------------------------------------------
bool Jiro_IsZenkaku1( unsigned char inCh )
{
	return ((inCh >= 0x81 && inCh <= 0x9F) || (inCh >= 0xE0 && inCh <= 0xFC)) ? true : false;
}

//-------------------------------------------------------------
// ֐ : Jiro_IsZenkaku2
// @\ : Sp̂QoCgځH
// ߒlF trueiSp̂QoCgځjAfalseiSp̂QoCgڂł͂Ȃj
//-------------------------------------------------------------
bool Jiro_IsZenkaku2( unsigned char inCh )
{
	return ((inCh >= 0x40) && (inCh <= 0xFC) && (inCh != 0x7F)) ? true : false;
}

//-------------------------------------------------------------
// ֐ : Jiro_IsNumberStr
// @\ : lH
// ߒl : trueiljAfalseilł͂Ȃj
//-------------------------------------------------------------
bool Jiro_IsNumberStr( char* inStr )
{
	while( *inStr )
	{
		if ( (isdigit(*inStr) == 0) && (*inStr != '-') && (*inStr != '+'))
		{
			return false;
		}
		inStr++;
	}
	return true;
}

//-------------------------------------------------------------
// ֐ : Jiro_IsNumOrPeriodStr
// @\ : l܂̓sIh̕H
// ߒl : trueiljAfalseilł͂Ȃj
//-------------------------------------------------------------
bool Jiro_IsNumOrPeriodStr( char* inStr )
{
	while( *inStr )
	{
		if ((isdigit(*inStr) == 0) && (*inStr != '.') && (*inStr != '-') && (*inStr != '+'))
		{
			return false;
		}
		inStr++;
	}
	return true;
}

//-------------------------------------------------------------
// ֐ : Jiro_LongToCommaString
// @\ : lR}t̕ɕϊ
//-------------------------------------------------------------
void Jiro_LongToCommaString( long inNum, char* outDestStr )
{
	char	numStr[50];
	
	sprintf( numStr, "%ld", inNum );
	Jiro_NumStrToCommaString( numStr, outDestStr );
}

//-------------------------------------------------------------
// ֐ : Jiro_NumStrToCommaStr
// @\ : lR}t̕ɕϊ
//-------------------------------------------------------------
void Jiro_NumStrToCommaString( char* inSrcStr, char* outDestStr )
{
	char	intStr[256];
	long	len, nInt,workPos;
	char*	periodPos;
	char	periodStr[256];
	char 	siginStr[10];
	
	if (inSrcStr[0] == '\0')
	{
		outDestStr[0] = '\0';
		return;
	}
	if (Jiro_IsNumOrPeriodStr(inSrcStr) == false)	// ƃR}ȊO̕H
	{
		strcpy( outDestStr, inSrcStr );	// ̂܂܋A
		return;
	}
	
	// _ȉ́̕AҔĂB
	periodStr[0] = '\0';
	periodPos = strrchr(inSrcStr,'.');
	if (periodPos)
	{
		*periodPos = '\0';
		strcpy(periodStr, periodPos + 1);
	}
	
	// ́AҔĂ
	siginStr[0] = '\0';
	if ((inSrcStr[0] == '+') || (inSrcStr[0] == '-'))
	{
		siginStr[0] = inSrcStr[0];
		siginStr[1] = '\0';
		inSrcStr++;
	}
	
	// ɃR}t쐬
	len = (long)strlen(inSrcStr);
	if (!len)
	{
		strcpy(intStr, "0");
	}
	else
	{
		workPos = len + (len-1) / 3;
		intStr[workPos--] = '\0';
		nInt = 0;
		while ((--len) >= 0)
		{
			if ((nInt % 3 == 0) && nInt)
			{
				intStr[workPos--] = ',';
			}
			intStr[workPos--] = inSrcStr[len];
			nInt++;
		}
	}
	if ((long)strlen(periodStr) >= 1)
	{
		sprintf( outDestStr, "%s%s.%s", siginStr, intStr, periodStr );
	}
	else
	{
		sprintf( outDestStr, "%s%s", siginStr, intStr );
	}
}

//-------------------------------------------------------------
// ֐ : Jiro_StripCharFromEnd
// @\ : ̌ɂAw蕶폜
//-------------------------------------------------------------
void Jiro_StripCharFromEnd( char* ioStr, char inDelCh )
{
	char* pos;
	
	if (*ioStr == '\0')
	{
		return;
	}
	
	pos = ioStr + (long)strlen(ioStr) - 1;
	while ((*pos == inDelCh) && (pos >= ioStr))
	{
		pos--;
	}
	
	*(pos + 1) = '\0';
}

//-------------------------------------------------------------
// ֐ : Jiro_StripCharFromStart
// @\ : ̐擪ɂAw蕶폜
//-------------------------------------------------------------
void Jiro_StripCharFromStart( char* ioStr, char inDelCh )
{
	long	len;
	long	delCnt;
	char*	pos;
	
	if (*ioStr == '\0')
	{
		return;
	}
	
	len = (long)strlen( ioStr );
	delCnt = 0;
	pos = ioStr;
	while( *pos == inDelCh )
	{
		delCnt++;
		pos++;
	}
	memmove( ioStr, ioStr + delCnt, len - delCnt + 1 );
}

//-------------------------------------------------------------
// ֐ : IsStartWithSplit
// @\ : Ώە؂蕶Ŏn܂Ă邩𔻒
//-------------------------------------------------------------
static bool IsStartWithSplit( const char* inStr, const char * inSplitStrAry[], long inSplitStrCnt, long* outSpilitIndex )
{
	int	i;

	for (i = 0; i < inSplitStrCnt; i++)
	{
		if (strstr(inStr, inSplitStrAry[i]) == inStr)
		{
			*outSpilitIndex = i;
			return true;
		}
	}
	return false;
}

//-------------------------------------------------------------
// ֐ : Jiro_GetSplitWordCount
// @\ : Ώە؂蕶ŋ؂ꍇ̒PꐔԂ
//-------------------------------------------------------------
long Jiro_GetSplitWordCount( const char* inStr, const char* inSplitStrAry[], long inSplitStrCnt )
{
	char *	pos;
	char *	wordStartPos = NULL;
	char *	wordEndPos = NULL;
	long	wordCnt = 0;
	long	foundSplitAryIndex;

	if (inStr == NULL || (*inStr) == 0)
	{
		return 0;
	}
	
	for (pos = (char*)inStr; *pos; pos++)
	{
		if (IsStartWithSplit(pos, inSplitStrAry, inSplitStrCnt, &foundSplitAryIndex))	// ؂蕶Ŏn܂H
		{
			// ؂蕶̏ꍇ
			if (wordStartPos && !wordEndPos)	// P̍ŒH
			{
				// PI
				wordEndPos = pos;
			}
			pos = pos + (strlen(inSplitStrAry[foundSplitAryIndex]) - 1);
		}
		else
		{
			// ؂蕶łȂꍇ
			if (!wordStartPos)	// P̍Œł͂ȂH
			{
				// PJn
				wordCnt++;
				wordStartPos = pos;
			}
		}

		if (*(pos + 1) == 0)	// Ō̕H
		{
			if (wordStartPos && !wordEndPos)	// P̍ŒH
			{
				// PI
				wordEndPos = pos + 1;
			}
		}

		if (wordStartPos && wordEndPos)		// PꂪIH
		{
			//PNA
			wordStartPos = NULL;
			wordEndPos = NULL;
		}
	}
	return wordCnt;
}


//-------------------------------------------------------------
// ֐ : Jiro_GetSplitWord
// @\ : Ώە؂蕶ŋ؂ꍇ̒PԂ
//-------------------------------------------------------------
void Jiro_GetSplitWord( const char* inStr, const char * inSplitStrAry[], long inSplitStrCnt, long inWordIndex, char * outWord, long inMaxLength )
{
	char *	pos;
	char *	wordStartPos = NULL;
	char *	wordEndPos = NULL;
	long	wordCnt = 0;
	long	copyLen;
	long	foundSplitAryIndex;

	*outWord = 0;

	if (inStr == NULL || (*inStr) == 0)
	{
		return;
	}
	
	for (pos = (char*)inStr; *pos; pos++)
	{
		if (IsStartWithSplit(pos, inSplitStrAry, inSplitStrCnt, &foundSplitAryIndex))	// ؂蕶Ŏn܂H
		{
			// ؂蕶̏ꍇ
			if (wordStartPos && !wordEndPos)	// P̍ŒH
			{
				// PI
				wordEndPos = pos;
			}
			pos = pos + (strlen(inSplitStrAry[foundSplitAryIndex]) - 1);
		}
		else
		{
			// ؂蕶łȂꍇ
			if (!wordStartPos)	// P̍Œł͂ȂH
			{
				// PJn
				wordCnt++;
				wordStartPos = pos;
			}
		}

		if (*(pos + 1) == 0)	// Ō̕H
		{
			if (wordStartPos && !wordEndPos)	// P̍ŒH
			{
				// PI
				wordEndPos = pos + 1;
			}
		}

		if (wordStartPos && wordEndPos)		// PꂪIH
		{
			if (wordCnt == (inWordIndex + 1))		// Ώۂ̒PH
			{
				// PԂ
				copyLen = (long)( wordEndPos - wordStartPos );
				if ( copyLen >= inMaxLength )
				{
					copyLen = inMaxLength - 1;
				}
				memcpy(outWord, wordStartPos, copyLen);
				outWord[copyLen] = 0;
				return;
			}
			//PNA
			wordStartPos = NULL;
			wordEndPos = NULL;
		}
	}
}

//-------------------------------------------------------------
// ֐ : Jiro_ReplaceString
// @\ : ̒u
//-------------------------------------------------------------
void Jiro_ReplaceString( char* ioTargetStr, const char* inFindStr, const char* inReplaceStr )
{
	long	findLen;
	long	replaceLen;
	char*	targetPos;
	char*	foundPos;
	char*	moveSrcPos;
	
	if (ioTargetStr == NULL)
	{
		return;
	}
	if (ioTargetStr[0] == '\0')
	{
		return;
	}
	if (inFindStr == NULL)
	{
		return;
	}
	if (inFindStr[0] == '\0')
	{
		return;
	}
	
	findLen = (long)strlen(inFindStr);
	if (inReplaceStr == NULL)
	{
		replaceLen = 0;
	}
	else
	{
		replaceLen = (long)strlen(inReplaceStr);
	}
	
	targetPos = ioTargetStr;
	foundPos = strstr(targetPos, inFindStr);
	while (foundPos)
	{
		moveSrcPos = foundPos + findLen;
		memmove(foundPos + replaceLen, moveSrcPos, (long)strlen(moveSrcPos) + 1);
		if (inReplaceStr)
		{
			memcpy(foundPos, inReplaceStr, replaceLen);
		}
		targetPos = foundPos + replaceLen;
		
		foundPos = strstr(targetPos, inFindStr);
	}
}

//-------------------------------------------------------------
// ֐ : Jiro_Num_To_2byteStr
// @\ : Spɕϊ
//-------------------------------------------------------------
void Jiro_Num_To_2byteStr( long inNum, char* outStr )
{
	char	numStr[20];
	long	i;
	long	len;
	
	sprintf(numStr, "%ld", inNum);
	len = (long)strlen(numStr);
	for (i = 0; i < len; i++)
	{
		outStr[i * 2] = (char)0x82;
		outStr[(i * 2) + 1] = 0x4F + (numStr[i] - 0x30);
	}
	outStr[len * 2] = '\0';
}


//-------------------------------------------------------------
// ֐ : Jiro_GetIndexOfLastChar
// @\ : Sp̍񂩂w肵pŌɏoĂCfbNXԂ
// add_tsunoda 030409
//-------------------------------------------------------------
long Jiro_GetIndexOfLastChar( const char* inStr, char inOffset )
{
	long index;
	
	index = (long)strlen( inStr );
	
	if( inStr == NULL )
	{
		return 0;
	}
	
	while( index >= 0 && 
		  !( inStr[index] == inOffset && Jiro_GetCharAttr(( unsigned char*)inStr,index) == 0 ) )
	{
		index--;
	}
	return index;
}

//-------------------------------------------------------------
// ֐ : Jiro_IsTheSamedDouble
// @\ : Q̂cntakd^vH
// add_hisa 050315
//-------------------------------------------------------------
bool Jiro_IsTheSamedDouble( double inVal1, double inVal2 )
{
	long	len;
	long	val1, val2;
	
	// x킹Ă
	val1 = (long)( inVal1 * 1000000 );
	val2 = (long)( inVal2 * 1000000 );
	len = val1 - val2;
	if( len == 0 )
	{
		return true;	// v
	}
	
	return false;	// sv
}

//-------------------------------------------------------------
// ֐ : Jiro_DoubleToChar
// @\ : cntakd^𕶎^ɕϊ( _ȉl )
// add_hisa 050315
//-------------------------------------------------------------
void Jiro_DoubleToChar( double inNumVal, char* outNumBuff )
{
	double	decimalVal;		// 
	double	integerVal;		// 
	double	multipleVal;	// 10{
	
	// _Ȃ
	integerVal = floor( inNumVal );
	decimalVal = inNumVal - integerVal;	
	if( Jiro_IsTheSamedDouble( decimalVal, 0.000000 ) == true )
	{
		sprintf( outNumBuff, "%.0f", inNumVal );
		return;	// _Ȃ
	}
	
	// _
	multipleVal = inNumVal * 10;
	integerVal = floor( multipleVal );	
	decimalVal = multipleVal - integerVal;
	if( Jiro_IsTheSamedDouble( decimalVal, 0.000000 ) == true )
	{
		sprintf( outNumBuff, "%.1f", inNumVal );
		return;	// _ʂ܂
	}
	
	// _
	multipleVal = inNumVal * 100;
	integerVal = floor( multipleVal );	
	decimalVal = multipleVal - integerVal;
	if( Jiro_IsTheSamedDouble( decimalVal, 0.000000 ) == true )
	{
		sprintf( outNumBuff, "%.2f", inNumVal );
		return;	// _ʂ܂
	}
	
	// _O
	multipleVal = inNumVal * 1000;
	integerVal = floor( multipleVal );	
	decimalVal = multipleVal - integerVal;
	if( Jiro_IsTheSamedDouble( decimalVal, 0.000000 ) == true )
	{
		sprintf( outNumBuff, "%.3f", inNumVal );
		return;	// _Oʂ܂
	}
	
	// _l
	multipleVal = inNumVal * 10000;
	integerVal = floor( multipleVal );	
	decimalVal = multipleVal - integerVal;
	if( Jiro_IsTheSamedDouble( decimalVal, 0.000000 ) == true )
	{
		sprintf( outNumBuff, "%.4f", inNumVal );
		return;	// _lʂ܂
	}
	
	// _܈
	multipleVal = inNumVal * 100000;
	integerVal = floor( multipleVal );	
	decimalVal = multipleVal - integerVal;
	if( Jiro_IsTheSamedDouble( decimalVal, 0.000000 ) == true )
	{
		sprintf( outNumBuff, "%.5f", inNumVal );
		return;	// _܈ʂ܂
	}
	
	// _Z
	sprintf( outNumBuff, "%.6f", inNumVal );
}

//-------------------------------------------------------------
// ֐ : Jiro_Malloc
// @\ : obt@m
// add_hisa 050315
//-------------------------------------------------------------
char* Jiro_Malloc( long inBuffSize )
{
	char*	outBuffer;
	
	outBuffer = ( char* )malloc( inBuffSize );
	if( outBuffer == NULL )
	{
		return NULL;
	}
	memset( outBuffer, 0, inBuffSize );
	
	return outBuffer;
}

//-------------------------------------------------------------
// ֐ : Jiro_MallocFree
// @\ : obt@
// add_hisa 050315
//-------------------------------------------------------------
void Jiro_MallocFree( void* inBuffer )
{
	if( inBuffer == NULL )
	{
		return;
	}
	free( inBuffer );
}

//-------------------------------------------------------------
// ֐F Jiro_GetViewDateStringFromDataChars
// @\ : 𕶎
// char inSourceChars[18]  // YYYYMMDDHHMMSS000
// char outDestStr[17]  // YYYY/MM/DD HH:MM
//			               01234567890123456
// add_igari 070220
//-------------------------------------------------------------
void Jiro_GetViewDateStringFromDataChars( char* inSourceChars, char* outDestStr )
{
	sprintf( outDestStr, "YYYY/MM/DD HH:MM" );
	memcpy( &(outDestStr[ 0]), &(inSourceChars[ 0]), 4 ); // YYYY
	memcpy( &(outDestStr[ 5]), &(inSourceChars[ 4]), 2 ); // MM
	memcpy( &(outDestStr[ 8]), &(inSourceChars[ 6]), 2 ); // DD
	memcpy( &(outDestStr[11]), &(inSourceChars[ 8]), 2 ); // HH
	memcpy( &(outDestStr[14]), &(inSourceChars[10]), 2 ); // MM
}

//-------------------------------------------------------------
// ֐F Jiro_GetFileSizeString
// @\ : t@CTCY擾
// add_igari 070220
//-------------------------------------------------------------
void Jiro_GetFileSizeString( long inFileSize, char* outFileSizeStr )
{
	double	sizeMB;
	double	sizeKB;
	
	// MBɕϊ
	sizeMB = (double)inFileSize / 1024.0 / 1024.0;
	
	// 1MBȏH
	if( 1.0 <= sizeMB )
	{
		// t@CTCYMBPʁA_ʂɂ
		sprintf( outFileSizeStr, "%.1f MB", sizeMB );		
		return;
	}
	
	// 1MBȂAKBPʁAʂɂ
	sizeKB = (double)inFileSize / 1024.0;	
	if( sizeKB <= 1.0 )
	{
		sizeKB = 0.000000;
	}
	sprintf( outFileSizeStr, "%.1f KB", sizeKB );
}

//-------------------------------------------------------------
// ֐ : Jiro_MakeVersionString 
// @\ : o[W쐬
// inComma = J}iOAPCQjAȊOׂ͂Ă̌
//-------------------------------------------------------------
void Jiro_MakeVersionString( const char* inValue, long inComma, char* outVersion )
{
	char	verStr1[8] = {0};
	long	ver1;
	char	verStr4[8] = {0};
	long	ver4;

	sprintf( verStr1, "%c%c", inValue[0], inValue[1] );
	ver1 = atol( verStr1 );
	// J}Ȃo[W
	if( inComma == 0 )
	{
		sprintf( outVersion, "%ld", ver1 );
	}
	// J}Po[W
	else if( inComma == 1 )
	{
		sprintf( outVersion, "%ld.%c", ver1, inValue[2] );
	}
	// J}Qo[W
	else if( inComma == 2 )
	{
		sprintf( outVersion, "%ld.%c.%c", ver1, inValue[2], inValue[3] );
	}
	// J}Ro[W
	else
	{
		sprintf( verStr4, "%c%c%c", inValue[4], inValue[5], inValue[6] );
		ver4 = atol( verStr4 );	
		sprintf( outVersion, "%ld.%c.%c (%ld)", ver1, inValue[2], inValue[3], ver4 );
	}
}

//-------------------------------------------------------------
// ֐ : Jiro_Strcmp
// @\ : 啶ʂɕr
//  : strcasecmpwindowsɂȂ̂ŁAOŎ
// add tamura 070828
//-------------------------------------------------------------
long Jiro_Strcmp( const char* inStr1, const char* inStr2 )
{
	long i;
	
	// 擪炽ǂĂ
	i = 0;
	while( inStr1[ i ] != '\0' )
	{
		// 啶ɂ낦Ăr
		if( toupper( (unsigned char)inStr1[ i ] ) != toupper( (unsigned char)inStr2[ i ] ) )  // s[2]kɂȂ炱ň
		{ // !
			return toupper( (unsigned char)inStr1[ i ] ) - toupper( (unsigned char)inStr2[ i ] );
		}
		
		// ̕ɐi
		i++;
	}
	// inStr1̍Ō܂Ō
	
	// inStr2܂cĂ邩Ȃ̂ŁAk(inStr1[i])Ɣr
	return toupper( (unsigned char)inStr1[ i ] ) - toupper( (unsigned char)inStr2[ i ] );
}

//-------------------------------------------------------------
// ֐ : Jiro_rindex
// @\ : Sp̍񂩂w肵pŌɏoĂʒuԂ
// Vtgihr
// add tamura 080606
//-------------------------------------------------------------
char* Jiro_rindex( const char* inStr, char inChar )
{
	long lastIndex;
	long i;
	
	// `FbN
	if( inStr == NULL )
	{
		return NULL;
	}
	
	// ̍Ō̈ʒu擾
	lastIndex = ( long )strlen( inStr );
	
	// 납猩Ďw̕T
	for( i = lastIndex;  0 <= i;  i-- )
	{
		// w̕
		if( ( inStr[ i ] == inChar ) &&
		   ( Jiro_GetCharAttr( ( unsigned char*)inStr, i ) == 0 ) // p
		   )
		{
			// ̈ʒuԂ
			return ( char* ) &( inStr[ i ] );
		}
	}
	
	// Ȃ
	return NULL;
}

//-------------------------------------------------------------
// ֐ : Jiro_index
// @\ : Sp̍񂩂w肵pŏɏoĂʒuԂ
// Vtgihr
// add tamura 080606
//-------------------------------------------------------------
char* Jiro_index( const char* inStr, char inChar )
{
	long lastIndex;
	long i;
	
	// `FbN
	if( inStr == NULL )
	{
		return NULL;
	}
	
	// TCY擾
	lastIndex = ( long )strlen( inStr );
	
	// O猩Ďw̕T
	for( i=0; i<lastIndex; i++ )
	{
		// w̕
		if( ( inStr[ i ] == inChar ) &&
		   ( Jiro_GetCharAttr( ( unsigned char*)inStr, i ) == 0 ) )	// p
		{
			// ̈ʒuԂ
			return ( char* ) &( inStr[ i ] );
		}
	}
	
	// Ȃ
	return NULL;
}

//-------------------------------------------------------------
// ֐ : Jiro_Strcasestr
// @\ : 񂪕񒆂ōŏɌʒuïɑ΂đ啶𖳎j
// add tamura 080606
//-------------------------------------------------------------
const char* Jiro_Strcasestr( const char* inHaystack, const char* inNeedle )
{
	const char*	pos;
	const char*	startn = NULL;
	const char*	nextPos = NULL;
	
	for ( pos = inHaystack; *pos; pos++ ) 
	{
		if ( nextPos != NULL ) 
		{
			if ( toupper( *pos ) == toupper( *nextPos ) ) 
			{
				if ( !*++nextPos )
				{
					return startn;
				}
			} 
			else
			{
				nextPos = NULL;
			}
		}
		else if ( toupper( *pos ) == toupper( *inNeedle ) ) 
		{
			nextPos = inNeedle + 1;
			startn = pos;
		}
	}
	
	return NULL;
}

//-------------------------------------------------------------
// ֐F Jiro_GetStringLength
// @\ : Spplāui{́hhQoCgł͂ȂPƔjv擾
// add_hisa 090513
//-------------------------------------------------------------
long Jiro_GetStringLength( const char* inStr )
{
	long	i, len;
	long	outMojisuu = 0;	// 
	short	rc;
	
	// P肵Ă
	len = (long)strlen( inStr );
	for( i=0; i<len; i++ )
	{
		// pA͑SpQoCgڂ̏ꍇA{P
		rc = Jiro_GetCharAttr( (unsigned char*)inStr, i );
		if( rc != 1 )
		{
			outMojisuu++;
		}
	}
	
	return outMojisuu;
}

//-------------------------------------------------------------
// ֐ : Jiro_GetTextEncoding
// @\ : GR[fBO擾
// add_hisa 090730
//-------------------------------------------------------------
bool Jiro_GetTextEncoding( const char* inTextData, long inTextDataSize, char* outEncoding )
{
	long	encode;
	
	// GR[fBO
	encode = GetEncoding( inTextData, inTextDataSize );
	if( encode == 0 )
	{
		strcpy( outEncoding, kEncodingShiftJIS );	// AXL[̏ꍇAVtgihrɂ
		return true;
	}
	if( encode == 1 )
	{
		strcpy( outEncoding, kEncodingShiftJIS );	// Vtgihr
		return true;
	}
	if( encode == 2 )
	{
		strcpy( outEncoding, kEncodingUTF8 );	// tseW
		return true;
	}
	if( encode == 3 )
	{
		strcpy( outEncoding, kEncodingEUC );	// dtb
		return true;
	}
	if( encode == 4 )
	{
		strcpy( outEncoding, kEncodingISO2022JP );	// hrn[QOQQ[io
		return true;
	}
	
	strcpy( outEncoding, kEncodingUnknown );	// ȊO͕s
	return false;
}

//-------------------------------------------------------------
// ֐ : GetEncoding
// @\ : GR[fBO擾
// qbgR[h̐GR[fBOԂ
// ׂăAXL[R[hȂAAXL[R[hƂĕԂ
// @OAXL[R[h
// @PVtgihr
// @QtseW
// @Rdtb
//   Shrn[QOQQ[io
// ?Ps
// add_hisa 090730
//-------------------------------------------------------------
static long GetEncoding( const char* inTextData, long inTextDataSize )
{
    long	numOfSJISCodes, numOfEUCCodes, numOfUTF8Codes;
	
	// hrn[QOQQ[ioH
	if( IsISO2022JP( inTextData, inTextDataSize ) == true )
	{
		return 4;	// hrn[QOQQ[io
	}
	
	// ׂăAXL[R[hō\ĂH
	if( IsASCII( inTextData, inTextDataSize ) == true )
	{
		return 0;	// AXL[R[hiVtgihrj
	}
	
	// Vtgihri?PȂVtgihr͂肦Ȃj
    numOfSJISCodes = CheckSJIS( inTextData, inTextDataSize );
	// tseWi?PȂtseW͂肦Ȃj
	numOfUTF8Codes = CheckUTF8( inTextData, inTextDataSize );
	// dtbi?PȂdtb͂肦Ȃj
    numOfEUCCodes = CheckEUC( inTextData, inTextDataSize );
	
	// ԃVtgihrƔ肳ꂽR[hH
    if ( 0 < numOfSJISCodes && numOfEUCCodes < numOfSJISCodes && numOfUTF8Codes < numOfSJISCodes )
	{
        return 1;	// Vtgihr
	}
	// ԃVtgtseWƔ肳ꂽR[hH
    else if ( 0 < numOfUTF8Codes && numOfEUCCodes < numOfUTF8Codes && numOfSJISCodes <= numOfUTF8Codes )
	{
        return 2;	// tseW
	}
	// ԂdtbƔ肳ꂽR[hH
	else if ( 0 < numOfEUCCodes && numOfSJISCodes <= numOfEUCCodes && numOfUTF8Codes <= numOfEUCCodes )
	{
        return 3;	// dtb
	}
	
    return (-1);	// s
}

//-------------------------------------------------------------
// ֐ : CheckUTF8
// @\ : tseW
// add_hisa 090730
//-------------------------------------------------------------
static long CheckUTF8( const char* inTextData, long inTextDataSize )
{
    unsigned char	byte1, byte2, byte3, byte4;
	long			i;
	long			outNumOfUTF8Codes = 0;
	bool			isBOM = false;
	
	// R[h̔Ă
    for( i=0; i<inTextDataSize; i++ ) 
    {
		// PoCgڂAXL[R[hȊOH
        byte1 = inTextData[i];
		if ( 0x7F < byte1 && i < (inTextDataSize-1) )
		{
			// QoCg
			byte2 = inTextData[i + 1];
			if ((byte1 >= 0xC0 && byte1 <= 0xDF) && (byte2 >= 0x80 && byte2 <= 0xBF))
			{
				i = i + 1;
				outNumOfUTF8Codes = outNumOfUTF8Codes + 2;
			}
            else if ( i < (inTextDataSize-2) )
            {
				// RoCg
                byte3 = inTextData[i + 2];
                if (byte1 == 0xEF && byte2 == 0xBB && byte3 == 0xBF)
                {
					isBOM = true;	// anlF0xEF 0xBB 0xBF
					i = i + 2;
					outNumOfUTF8Codes = outNumOfUTF8Codes + 3;
				}
				else if ( ( byte1 >= 0xE0 && byte1 <= 0xEF ) && 
						 ( byte2 >= 0x80 && byte2 <= 0xBF ) && 
						 ( byte3 >= 0x80 && byte2 <= 0xBF ) )
				{
					i = i + 2;
					outNumOfUTF8Codes = outNumOfUTF8Codes + 3;
				}
                else if ( i < (inTextDataSize-3) )
                {
					// SoCg
                    byte4 = inTextData[i + 3];
                    if ((byte1 >= 0xF0 && byte1 <= 0xF7) &&
                        (byte2 >= 0x80 && byte2 <= 0xBF) &&
                        (byte3 >= 0x80 && byte2 <= 0xBF) &&
                        (byte4 >= 0x80 && byte2 <= 0xBF))
                    {
						i = i + 3;
						outNumOfUTF8Codes = outNumOfUTF8Codes + 4;
					}
                }
                else
                {
                    return (-1);
                }
            }
        }
    }
	
    return outNumOfUTF8Codes;
}

//-------------------------------------------------------------
// ֐ : CheckSJIS
// @\ : VtgihrR[h菈
// add_hisa 090730
//-------------------------------------------------------------
static long CheckSJIS( const char* inTextData, long inTextDataSize )
{
	unsigned char	byte1, byte2;
	long			outNumOfSJISCodes = 0;
	long			i;
	
	// R[h̔Ă
	for( i=0; i<inTextDataSize; i++ )
	{
		// PoCgڂAXL[R[hH
		byte1 = inTextData[ i ];
		if ( 0x00 <= byte1 && byte1 <= 0x7F )
		{
			// AXL[R[hi0x00?0x7Fj
		}
		else if( 0xA1 <= byte1 && byte1 <= 0xDF )
		{
			// pJ^Jii0xA1?0xDFj
			outNumOfSJISCodes = outNumOfSJISCodes + 1;
		}
		// AXL[R[hApJ^JiȊOH
		else if( i < (inTextDataSize-1) )
		{
			// PoCg: 0x81?0x9FA0xE0?0xFC
			// QoCg: 0x40?0x7EA0x80?0xFC
			byte2 = inTextData[ i+1 ];
			if ( ( ( 0x81 <= byte1 && byte1 <= 0x9F ) || ( 0xE0 <= byte1 && byte1 <= 0xFC ) ) &&
				( ( 0x40 <= byte2 && byte2 <= 0x7E ) || ( 0x80 <= byte2 && byte2 <= 0xFC ) ) )
			{
				i++;
				outNumOfSJISCodes = outNumOfSJISCodes + 2;
			}
			else
			{
				return (-1);	// Vtgihrł͂Ȃ
			}
		}
	}
	
	return outNumOfSJISCodes;
}

//-------------------------------------------------------------
// ֐ : CheckEUC
// @\ : dtbR[h菈
// add_hisa 090730
//-------------------------------------------------------------
static long CheckEUC( const char* inTextData, long inTextDataSize )
{
	unsigned char	byte1, byte2, byte3;
	long			outNumOfEUCCodes = 0;
	long			i;
	
	// R[h̔Ă
	for( i=0; i<inTextDataSize; i++ )
	{
		// PoCgڂAXL[R[hȊOH
		byte1 = inTextData[i];
		if ( 0x7F < byte1 && i < (inTextDataSize-1) )
		{
			byte2 = inTextData[i + 1];
			
			// FPoCgi0xA1?0xFEjAQoCgi0xA1?0xFEjH
			if( (byte1 >= 0xA1 && byte1 <= 0xFE) && (byte2 >= 0xA1 && byte1 <= 0xFE) )
			{
				i++;
				outNumOfEUCCodes = outNumOfEUCCodes + 2;
			}
			// pJ^JiFPoCgi0x8Ej, QoCgi0xA1?0xDFj
			else if( (byte1 == 0x8E) && (byte2 >= 0xA1 && byte1 <= 0xDF) )
			{ 
				i++;
				outNumOfEUCCodes = outNumOfEUCCodes + 2;
			}
			// RoCgڂH
			else if ( i < (inTextDataSize-2) )
			{
				// ⏕FPoCgi0x8FjAQoCgi0xA1?0xFEjA3oCgi0xA1?0xFEj
				byte3 = inTextData[i + 2];
				if ( (byte1 == 0x8F) && (byte2 >= 0xA1 && byte2 <= 0xFE) && (byte3 >= 0xA1 && byte3 <= 0xFE) )
				{ 
					i = i + 2;
					outNumOfEUCCodes = outNumOfEUCCodes + 3;
				}
				else
				{
					return (-1);	// dtbł͂Ȃ
				}
			}
			// ȊO
			else
			{
				return (-1);	// dtbł͂Ȃ
			}
		}
	}
	
	return outNumOfEUCCodes;
}

//-------------------------------------------------------------
// ֐ : IsASCII
// @\ : AXL[
// add_hisa 090730
//-------------------------------------------------------------
static bool IsASCII( const char* inTextData, long inTextDataSize )
{
	unsigned char	byte1;
	long			i;
	
	// R[h̔Ă
    for( i=0; i<inTextDataSize; i++ ) 
    {
		// AXL[R[hH
        byte1 = inTextData[i];
		if( 0x7E < byte1 )
        {
			return false;	// AXL[R[hȊÕR[h
        }
    }
	
    return true;	// ׂăAXL[R[h
}

//-------------------------------------------------------------
// ֐ : IsISO2022JP
// @\ : hrn[QOQQ[io
// add_hisa 090818
//-------------------------------------------------------------
static bool IsISO2022JP( const char* inTextData, long inTextDataSize )
{
	unsigned char	byte1, byte2, byte3, byte4, byte5, byte6;
	long			i;
	
	// R[h̔Ă
    for( i=0; i<inTextDataSize; i++ ) 
	{
		// PoCgڂhrn[QOQQ[io (0x00?0x7F)  ͈͊O
		byte1 = inTextData[ i ];
		if( byte1 > 0x7F )
		{
			return false;
		}
		else if( i < inTextDataSize-2 )
		{
			// GXP[vV[PXH
			byte2 = inTextData[ i+1 ];
			byte3 = inTextData[ i+2 ];
			if( byte1 == 0x1B && byte2 == 0x28 && byte3 == 0x42 )
			{
				return true;    // drb ( B FJIS ASCII
			}
			else if( byte1 == 0x1B && byte2 == 0x28 && byte3 == 0x4A )
			{
				return true;    // drb ( JFJIS X 0201-1976 Roman Set
			}
			else if( byte1 == 0x1B && byte2 == 0x28 && byte3 == 0x49 )
			{
				return true;    // drb ( IFJIS X 0201-1976 Љ
			}
			else if( byte1 == 0x1B && byte2 == 0x24 && byte3 == 0x40 )
			{
				return true;    // drb $ @FJIS X 0208-1978(ʏ́FJIS)
			}
			else if( byte1 == 0x1B && byte2 == 0x24 && byte3 == 0x42 )
			{
				return true;    // drb $ BFJIS X 0208-1983(ʏ́FVJIS)
			}
		}
		else if( i < inTextDataSize-3 )
		{
			// GXP[vV[PXH
			byte2 = inTextData[ i+1 ];
			byte3 = inTextData[ i+2 ]; 
			byte4 = inTextData[ i+3 ];
			if( byte1 == 0x1B && byte2 == 0x24 && byte3 == 0x28 && byte4 == 0x44 )
			{
				return true;    // ESC $ ( DFJIS X 0212-1990iJIS⏕j
			}
		}
		else if( i < inTextDataSize-5 )
		{
			// GXP[vV[PXH
			byte2 = inTextData[ i+1 ];
			byte3 = inTextData[ i+2 ];
			byte4 = inTextData[ i+3 ];
			byte5 = inTextData[ i+4 ];
			byte6 = inTextData[ i+5 ];
			if ( byte1 == 0x1B && byte2 == 0x26 && byte3 == 0x40 && byte4 == 0x1B && byte5 == 0x24 && byte6 == 0x42 )
			{
				return true;    // ESC & @ ESC $ BFJIS X 0208-1990
			}
		}
	}
	
	return false;	// hrn[QOQQ[ioł͂Ȃ
}

//----------------------------------------------
// ֐ : Jiro_StrToLower
// @\ : 񒆂̉p啶ɕϊ
// add_hisa 110720
//----------------------------------------------
const char* Jiro_StrToLower( const char* inStr )
{
    char*	pos;	// Ɨp|C^

    for( pos=(char*)inStr; *pos; pos++ )
	{
        *pos = tolower( *pos );	// ɕϊ
	}

	return inStr;
}

//----------------------------------------------
// ֐ : Jiro_FindLastString
// @\ : 񂩂ŌɌ
// EŌɌꂽ̐擪w|C^ԂBȂꍇ͂mtkkԂB
// EI[ '\0' ͌ΏۂƂȂȂ
// Epp̑啶Əʂ
// add_hisa 110720
//------------------------------------------------
char* Jiro_FindLastString( const char* inTargetStr, const char* inSearchStr )
{
	const char*	last = NULL;
	const char*	p = NULL;
	
	// I[ɒB܂ŌJԂB
	for( p = inTargetStr; NULL != ( p = strstr( p, inSearchStr ) ); ++p )
	{
		last = p;
		if ( '\0' == *p )
		{
			return (char *)last;
		}
	}
	
	return (char *)last;
}

//-------------------------------------------------------------
// ֐ : Jiro_ConvertSecToDateString
// @\ : btɕϊ
// add_sugimoto 080606
// mod_wat 120605 - wŌxłӏBJbRđΉ
//-------------------------------------------------------------
void Jiro_ConvertSecToDateString( unsigned long inSec, char* outTimeStr )
{
	long i;
	long day;
	long month;
	long year;
	long monthData[12];
	long daysByYear = 365;
	long uruudosi = 0;
	
	// 
	year = 2000;
	// bɕύXiOPɂ邽߂ɐ؂グj
	day = inSec / 86400 + 1;		// P͂WUSOOb	
	// N̒o
	while( 0 < day )
	{
		if( ( year%4 == 0 && year%100 != 0 ) || year%400 == 0 )	// mod_wat 120605
		{
			// [N
			daysByYear= 366;
			uruudosi = 1;
		}
		else
		{
			// N
			daysByYear= 365;
			uruudosi = 0;
		}
		if( day - daysByYear > 0 )
		{
			// ̔N	
			year++;
			day -= daysByYear;
		}
		else
		{
			// N
			break;
		}
	}
	
	// cf[^͂̔N̂PP̓ɂȂ
	// f[^쐬
	monthData[0] = 31;					// P
	monthData[1] = 28 + uruudosi; 		// Q
	monthData[2] = 31; 					// R
	monthData[3] = 30; 					// S
	monthData[4] = 31; 					// T
	monthData[5] = 30; 					// U
	monthData[6] = 31; 					// V
	monthData[7] = 31; 					// W
	monthData[8] = 30; 					// X
	monthData[9] = 31; 					// PO
	monthData[10] = 30; 				// PP
	monthData[11] = 31; 				// PQ
	month = 0;
	for( i=0; i<12; i++ )
	{
		if( day - monthData[i] > 0 )
		{
			// Ƃɓ炷
			day -= monthData[i];
		}
		else
		{
			// 
			month = i+1;
			break;
		}
	}
	
	sprintf( outTimeStr, "%ld%ld", month, day );
}
