// TYPE: C
// PRJ: JCL
// PGM: Jiro_TAB
// VER: 1.40
// USES: CodeWarrior, VC, Xcode
// CREATE: 1999/02/21( Shiratori )
// UPDATE: 2000/06/02( Shiratori )
// CREATE: 2007/04/02( tamura )
// UPDATE: 2009/03/16( igari, tamura )
// UPDATE: 2011/03/02( hisa )
/////////////////////////////////////////////////////
// 000602 - lr-cnr`̉sɂΉ
// 070402 - Linux(CR/LF/CRLFɑΉ)
// 090316 - 񐔎擾֐ǉ
// 110302 - l^ɑΉ

// MFCvWFNggpꍇ́AL̃RgOB
#include "stdafx.h"

// runtime
#include <string.h>
#include <stdlib.h>

//JCL
#include "Jiro_Const.h"
#include "Jiro_TAB.h"

//*************************************************************************
// ֐̃vg^Cv錾
//*************************************************************************
static bool GetColumnData(char * rowStartPos,	// s̐擪ʒu
							char * rowEndPos,		// s̏Iʒu
							long	columnNo,		// ԍi0j
							char *	outBufPtr,		// f[^o͐iCj
							long	bufLength,		// o͂̍ő咷
							long * outRealLength)	// ۂ̒
     ;
static void SetOutPutBuffer(char * textPos,
							long textLen, 
							char *	outBuf,
							long	bufLength,
							long *	outRealLength)
     ;
static char * SearchCRorLF( const char * inStr );
static char * SearchNextLine( const char * inStr );
static long GetNumOfColumns( char* inRowStartPos, char* inRowEndPos );

//*************************************************************************
// ֐
//*************************************************************************
//--------------------------------------------------
// ֐ : Jiro_TAB_Init
// @\ : TABe[u (CSVf[^Zbg)
//--------------------------------------------------
void Jiro_TAB_Init( JIRO_TAB * outTabTblPtr, char * inTextPtr )
{
	// ւ̃|C^Zbg
	outTabTblPtr->textPtr = inTextPtr;

	// ̍Ō(NULL)ւ̃|C^Zbg
	if( inTextPtr != NULL )
	{
		outTabTblPtr->textEndPos = inTextPtr + strlen( inTextPtr );
	}
	else
	{
		outTabTblPtr->textEndPos = NULL;
	}

	// ݂̍s̈ʒu
	outTabTblPtr->currentRowPos = NULL;
}

//--------------------------------------------------
// ֐ : SearchCRorLF
// @\ : CR܂LFT
// Ԓl : ŏɌCR܂LFւ̃|C^
//        ȂNULL
// -------------------------------------------------
static char * SearchCRorLF( const char * inStr )
{
	char * crPtr;
	char * lfPtr;

	// ŏCR̈ʒuT
	crPtr = (char *)strchr( inStr, kJIRO_CR );

	// ŏLF̈ʒuT
	lfPtr = (char *)strchr( inStr, kJIRO_LF );

	// CRȂƂ́ALF̈ʒuԂ
	if( crPtr == NULL )
	{
		return lfPtr;
	}

	// LFȂƂ́ACR̈ʒuԂ
	if( lfPtr == NULL )
	{
		return crPtr;
	}

	// CRLFƂ́AŏɌق
	if( crPtr < lfPtr )
	{ // CR
		return crPtr;
	}
	else
	{ // LF
		return lfPtr;
	}
}

//--------------------------------------------------
// ֐ : SearchNextLine
// @\ : ̍sT
// Ԓl : ̍s̐擪ւ̃|C^
//        ȂNULL
//--------------------------------------------------
static char * SearchNextLine( const char * inStr )
{
	char * charCRorLFPtr;
	char nextChar;
	char * nextLinePtr;

	// ŏCRLFT
	charCRorLFPtr = SearchCRorLF( inStr );

	// ȂNULLԂ
	if( charCRorLFPtr == NULL )
	{
		return NULL;
	}

	// CR/LF/CRLF̎̕T
	if( charCRorLFPtr[0] == kJIRO_CR )
	{ // CR
		// ̕擾
		nextChar = charCRorLFPtr[1];

		// ̕LFCRLF
		if( nextChar == kJIRO_LF )
		{ // CRLF
			// CRLF2΂
			nextLinePtr = &( charCRorLFPtr[2] );
		}
		else
		{ // CR
			// CR1΂
			nextLinePtr = &( charCRorLFPtr[1] );
		}
	}
	else
	{ // LF
		// CR1΂
		nextLinePtr = &( charCRorLFPtr[1] );
	}

	return nextLinePtr;
}

//--------------------------------------------------
// ֐ : Jiro_TAB_GetRowCount
// @\ : s擾
//  : CR/LF/CRLFɑΉ
//--------------------------------------------------
long Jiro_TAB_GetRowCount( JIRO_TAB * inTabTblPtr )
{
	char *	rowStartPos;  // s̊Jnʒu
	long	rowCnt;
	
	rowCnt = 0;
	rowStartPos = inTabTblPtr->textPtr;
	while ( rowStartPos < inTabTblPtr->textEndPos )
	{
		rowCnt += 1;

		// ̍sT
		rowStartPos = SearchNextLine( rowStartPos );
		if( rowStartPos == NULL )
		{
			break;
		}
	}
	return rowCnt;
}

//--------------------------------------------------
// ֐ : Jiro_TAB_FirstRow
// @\ : ŏ̍sɈړ
//--------------------------------------------------
bool Jiro_TAB_FirstRow( JIRO_TAB * inTabTblPtr )
{
	// ݂̈ʒuZbg
	inTabTblPtr->currentRowPos = NULL;
	if( inTabTblPtr->textPtr == NULL )
	{
		return false;
	}

	// memo tamura 070403 // ȂŔrĂ̂킩Ȃ
	if( inTabTblPtr->textPtr < inTabTblPtr->textEndPos )
	{
		inTabTblPtr->currentRowPos = inTabTblPtr->textPtr;
		return true;
	}
	return false;
}

//--------------------------------------------------
// ֐ : Jiro_TAB_NextRow
// @\ : ̍sɈړ
// Ԓl : ړłtrueAłȂfalse
//--------------------------------------------------
bool Jiro_TAB_NextRow(JIRO_TAB * inTabTblPtr )
{
	char * nextLinePos;
	
	// NULLړȂ
	if( inTabTblPtr->textPtr == NULL )
	{
		return false;
	}
	if( inTabTblPtr->currentRowPos == NULL )
	{
		return false;
	}

	// ̍sT
	nextLinePos = SearchNextLine( inTabTblPtr->currentRowPos );
	if( nextLinePos == NULL )
	{ // Ȃ
		inTabTblPtr->currentRowPos = NULL;
		return false;
	}
	else
	{ // 
		inTabTblPtr->currentRowPos = nextLinePos;
		return true;
	}
}

// -------------------------------------------------
// ֐ : Jiro_TAB_GetFieldData
// @\ : ݂̍s̎w肳ꂽ̃f[^擾
// inTabTblPtr (in) : TAB e[u
// column (in) : 擾tB[h̔ԍ(0 ͂܂)
// bufLength (out) : tB[h̒l̃TCY
// outBufPtr (out) : tB[h̒l
// -------------------------------------------------
bool Jiro_TAB_GetFieldData( JIRO_TAB* inTabTblPtr, long inColumn, long inBufLength, char* outBufPtr )
{
	char *	rowEndPos;  // s̏Iʒu (sNULL)
	long	realLength;
	bool	rc;
	
	outBufPtr[0] = '\0';

	// NULL`FbN
	if( inTabTblPtr->currentRowPos == NULL )
	{
		return false;
	}

	// s̏IT
	rowEndPos = SearchCRorLF( inTabTblPtr->currentRowPos );
	if( rowEndPos == NULL )
	{ // Ȃ
		// ̏Is̏IƂ
		rowEndPos = inTabTblPtr->textEndPos;
	}

	// tB[h̒l擾
	rc = GetColumnData( inTabTblPtr->currentRowPos, rowEndPos, inColumn, outBufPtr, inBufLength, &realLength );

	return rc;
}

// -------------------------------------------------
// ֐ : Jiro_TAB_GetFieldSize
// @\ : ݂̍s̎w肳ꂽ̕擾
//--------------------------------------------------
long Jiro_TAB_GetFieldSize( JIRO_TAB * inTabTblPtr, long inColumn )
{
	char *	rowEndPos;		// s̏Iʒu
	long	realLength = 0L;
	bool	rc;

	// NULL`FbN
	if( inTabTblPtr->currentRowPos == NULL )
	{
		return realLength;
	}

	// s̏IT
	rowEndPos = SearchCRorLF( inTabTblPtr->currentRowPos );
	if( rowEndPos == NULL )
	{ // Ȃ
		// ̏Is̏IƂ
		rowEndPos = inTabTblPtr->textEndPos;
	}

	// tB[h̑擾
	rc = GetColumnData( inTabTblPtr->currentRowPos, rowEndPos, inColumn, NULL, 0, &realLength );

	// tB[h̕ԂB
	return realLength;
}

// -------------------------------------------------
// ֐F GetColumnData
// @\F  ݂̍s̎w肳ꂽ̃f[^擾B
// ߒlF kJIRO_RC_noErroritB[h؂ojAkJIRO_RC_tabFailedi񂪂Ȃj
// -------------------------------------------------
static bool GetColumnData(char * rowStartPos,	// s̐擪ʒu
							char * rowEndPos,		// s̏Iʒu
							long	columnNo,		// ԍi0j
							char *	outBufPtr,		// f[^o͐iCj
							long	bufLength,		// o͂̍ő咷
							long * outRealLength)	// ۂ̒
{
	char *	targetPos;
	char *	columnStartPos;
	char *	columnEndPos;
	long	columnCnt;
	long	textLen;
	
	*outRealLength = 0;
	
	if (outBufPtr != NULL)
	{
		*outBufPtr = '\0';
	}

	columnCnt = 0;
	targetPos = rowStartPos;
	columnStartPos = rowStartPos;
	while (targetPos < rowEndPos)
	{
		if (*targetPos == kJIRO_TAB)	// TAB?
		{
			columnEndPos = targetPos;
			columnCnt++;
			if (columnCnt - 1 == columnNo)
			{
				// tB[h̒lݒ肷
				textLen = (long)( columnEndPos - columnStartPos );
				SetOutPutBuffer( columnStartPos, textLen, outBufPtr, bufLength, outRealLength );
				return true;
			}
			
			targetPos++;
			columnStartPos = targetPos;
		}
		else
		{
			targetPos++;
			if (targetPos >= rowEndPos)
			{
				columnCnt++;
				columnEndPos = targetPos;
				if (columnCnt - 1 == columnNo)
				{
					// tB[h̒lݒ肷
					textLen = (long)( columnEndPos - columnStartPos );
					SetOutPutBuffer(columnStartPos, textLen, outBufPtr, bufLength, outRealLength);
					return true;
				}
				else
				{
					return false;
				}
			}
		}
	}
	columnCnt++;
	if (columnCnt - 1 == columnNo)
	{
		return true;
	}

	return false;
}

// -------------------------------------------------
// ֐F SetOutPutBuffer
// @\F  tB[hlݒ肷B
// -------------------------------------------------
static void SetOutPutBuffer(char * textPos,
							long textLen, 
							char *	outBuf,
							long	bufLength,
							long *	outRealLength)
{
	*outRealLength = textLen;
	if (outBuf != NULL)
	{
		if (textLen >= bufLength)
		{
			textLen = bufLength - 1;
		}
		
		memcpy(outBuf, textPos, textLen);
		outBuf[textLen] = '\0';
		*outRealLength = textLen;
	}
}

// -------------------------------------------------
// ֐ : Jiro_TAB_GetNumOfColumns
// @\ : ݂̍s̗񐔂擾
// add_igari 090316
// -------------------------------------------------
long Jiro_TAB_GetNumOfColumns( JIRO_TAB * inTabTblPtr )
{
	char*	rowEndPos;		// s̏Iʒu
	long	numOfCols;
		
	if ( inTabTblPtr->currentRowPos == NULL )
	{
		return -1;
	}

	rowEndPos = strchr( inTabTblPtr->currentRowPos, kJIRO_CR );	// CR
	if (rowEndPos == NULL)
	{
		rowEndPos = inTabTblPtr->textEndPos;
	}

	numOfCols = GetNumOfColumns( inTabTblPtr->currentRowPos, rowEndPos );

	return numOfCols;
}

// -------------------------------------------------
// ֐F GetNumOfColumns
// @\F Jgs̗񐔂擾
// ߒlF 
// -------------------------------------------------
static long GetNumOfColumns( char* inRowStartPos, char* inRowEndPos )
{
	char*	targetPos;
	long	columnCnt;
	
	columnCnt = 0;
	targetPos = inRowStartPos;
	while (targetPos < inRowEndPos)
	{
		if (*targetPos == kJIRO_TAB)	// TAB?
		{
			columnCnt++;
			targetPos++;
		}
		else
		{
			targetPos++;
			if (targetPos >= inRowEndPos)
			{
				columnCnt++;
				return columnCnt;
			}
		}
	}
	columnCnt++;
	
	return columnCnt;
}

// -------------------------------------------------
// ֐ : Jiro_TAB_GetFieldDoubleValue
// @\ : ݂̍s̎w肳ꂽ񂩂cntakd^f[^擾
// add_hisa 110302
// -------------------------------------------------
double Jiro_TAB_GetFieldDoubleValue( JIRO_TAB* inTabTblPtr, long inColumn )
{
	char	rowBuff[ 64 ] = {0};
	double	value = 0;

	Jiro_TAB_GetFieldData( inTabTblPtr, inColumn, 64, rowBuff );
	value = atof( rowBuff );

	return value;
}

// -------------------------------------------------
// ֐ : Jiro_TAB_GetFieldIntValue
// @\ : ݂̍s̎w肳ꂽ񂩂琔l^f[^擾
// add_hisa 110302
// -------------------------------------------------
long Jiro_TAB_GetFieldIntValue( JIRO_TAB* inTabTblPtr, long inColumn )
{
	char	rowBuff[ 64 ] = {0};
	long	value = 0;

	Jiro_TAB_GetFieldData( inTabTblPtr, inColumn, 64, rowBuff );
	value = atol( rowBuff );

	return value;
}
