// TYPE: C
// PRJ: JCL
// PGM: Jiro_File
// VER: 1.00
// USES: CodeWarrior7.2Pro, JCL
// CREATE: 2000/11/27( Siratori )
// UPDATE: 2003/09/15( Hisa )
// UPDATE: 2005/07/05( Hisa )
// UPDATE: 2012/06/26( Hisa )
/////////////////////////////////////////////////////
// t@C֘Å֐Q
// MFCvWFNggpꍇ́AL̃RgOB
#include "stdafx.h"

#include <stdio.h>
#include <string.h>
#include <stdarg.h>
#include <stdlib.h>
#include <time.h>
#include <windows.h> 
#include <shlwapi.h>
#include <shlobj.h>

// JCL
#include "Jiro_File.h"
#include "Jiro_String.h"
#include "Jiro_Types.h"

//*************************************************************************
// ֐̃vg^Cv錾
//*************************************************************************

//*************************************************************************
// ֐
//*************************************************************************
//-----------------------------------------------------
// ֐ : Jiro_LogOut
// @\ : ԕtOt@Co
//-----------------------------------------------------
void Jiro_LogOut( char * inFormat, ... )
{
	FILE*		fp = NULL;
	va_list		args;
	char		msg[ 65535 ] = {0};
	time_t		timer;
	struct tm*	timePtr;
	char		desktopPath[ MAX_PATH ] = {0};
	char		logFilePath[ MAX_PATH ] = {0};

	// Ot@CJ
	Jiro_GetDesktopPath( desktopPath );	// fXNgbṽpX擾
	sprintf( logFilePath, "%s%s", desktopPath, kLogFileName );	
	fp = fopen( logFilePath, "a" );
	if ( fp == NULL )
	{
		return;
	}
	
	// tƎԂo
	timer = time( NULL );
	timePtr = localtime( &timer );
	fprintf( fp, "%04d/%02d/%02d %02d:%02d:%02d  ",
			  timePtr->tm_year + 1900,  // int tm_year;    /* years since 1900 */
			  timePtr->tm_mon  + 1,     // int tm_mon;     /* months since January - [0,11] */
			  timePtr->tm_mday,
			  timePtr->tm_hour,
			  timePtr->tm_min,
			  timePtr->tm_sec );
	
	// bZ[Wot_st
	va_start( args, inFormat );
	vsprintf( msg, inFormat, args );
	fwrite( msg, 1, strlen( msg ), fp );
	va_end( args );

	fclose( fp );
}

//-----------------------------------------------------
// ֐ : LogDelete
// @\ : o͂Ot@C폜
//-----------------------------------------------------
void Jiro_LogDelete()
{
	char		desktopPath[ MAX_PATH ] = {0};
	char		logFilePath[ MAX_PATH ] = {0};

	// Ot@C폜
	Jiro_GetDesktopPath( desktopPath );	// fXNgbṽpX擾
	sprintf( logFilePath, "%s%s", desktopPath, kLogFileName );	
	remove( logFilePath );
}

//-----------------------------------------------------
// ֐ : Jiro_ReadBuffer_fromFile
// @\ : t@Cobt@ɓǂݍ
//-----------------------------------------------------
long Jiro_ReadBuffer_fromFile( const char* inFilePath, char** outBuff )
{
	FILE *	fp = NULL;
	long	size;

	*outBuff = NULL;
	
	// t@CJ
	fp = fopen( inFilePath, "rb" );
	if ( fp == NULL )
	{
		return (-1);
	}
	
	// t@CTCY擾
	fseek( fp, 0, SEEK_END );
	size = ftell( fp );
	fseek( fp, 0L, SEEK_SET );
	
	// obt@AP[g
	*outBuff = ( char* )malloc( size + 1 );
	if ( *outBuff != NULL )
	{
		// t@Cǂݍ
		memset( *outBuff, '\0', size+1 );
		fread( *outBuff, 1, size, fp );
	}
	
	// t@C
	fclose( fp );
	
	return size;
}

//-----------------------------------------------------
// ֐ : Jiro_IsFileExists
// @\ : wt@C݂邩ׂ
// Ԓl : true	... ݂
//        false	... ݂Ȃ
// 20050831 add (shiina, yatou)  t@C݂̑fopenŒׂ邵Ȃ
//-----------------------------------------------------
bool Jiro_IsFileExists( const char * inFilePath )
{
	FILE * fp;

	// t@Cǂݍ݃[hŎɊJ
	fp = fopen( inFilePath, "r" );
	if( fp == NULL )
	{
		return false;	// t@C݂Ȃ
	}
	
	fclose( fp );
	return true;	// t@C݂
}

//-----------------------------------------------------
// ֐ : Jiro_GetFileName
// @\ : t@CpXt@Co
// add_tamura 071026
//-----------------------------------------------------
void Jiro_GetFileName( const char* inFilePath, char* outFileName )
{
	long	i, j;
	long	folderPathLen;
	long	filePathLen;
	
	// ṒT
	filePathLen = (long)strlen( inFilePath );
	folderPathLen = Jiro_GetIndexOfLastChar( inFilePath, '\\' );
	j = 0;
	for( i=folderPathLen+1; i<filePathLen; i++ )
	{
		outFileName[j] = inFilePath[i];
		j++;
	}
	outFileName[j] = '\0';	// mtkkI[
}

//-----------------------------------------------------
// ֐ : Jiro_GetDesktopPath
// @\ : fXNgbvpX擾
//-----------------------------------------------------
void Jiro_GetDesktopPath( char* outDesktopPath )
{
	char	desktopPath[ MAX_PATH ] = {0};

	// fXNgbṽpX擾
	SHGetSpecialFolderPath( NULL, (LPSTR)desktopPath, CSIDL_DESKTOP, FALSE );
	sprintf( outDesktopPath, "%s\\", desktopPath );
}

//-----------------------------------------------------
// ֐ : Jiro_GetAppDirectoryPath
// @\ : exe(s\t@C)fBNgpX擾
// GetCurrentDirectory( MAX_PATH, outAppDirPath );	ł́A
// Avփt@ChbvċNƂAst@CpX擾łȂ
//-----------------------------------------------------
void Jiro_GetAppDirectoryPath( char* outAppDirPath )
{
	char	appPath[ MAX_PATH ];

	// .exe(s\t@C)fBNgpX擾
	GetModuleFileName( NULL, (LPCH)appPath, MAX_PATH );
	Jiro_GetFolderPath( appPath, true, outAppDirPath );
}

//-----------------------------------------------------
// ֐ : Jiro_GetExtension
// @\ : gq擾
// add_hisa 081024
//-----------------------------------------------------
void Jiro_GetExtension( const char* inFilePath, char* outExt )
{
	char*	pos;
	long	findStrLen;

	// Ώە̒擾
	findStrLen = (long)strlen( inFilePath );
	
	// ṒugqvT
	pos = Jiro_rindex( inFilePath, '.' );	// for Win
	if( pos == NULL )
	{
		strcpy( outExt, "" );
		return;
	}
	
	// t@COpXAṒupX؂蕶vT
	pos++;
	strncpy( outExt, pos, 15 );
}

//-----------------------------------------------------
// ֐ : Jiro_IsFolder
// @\ : tH_ǂ
//-----------------------------------------------------
bool Jiro_IsFolder( const char* inFileOrFolderPath )
{	
	// fBNgł͂ȂH
	if( PathIsDirectory( (LPCH)inFileOrFolderPath ) == false )
	{
		return false;	// fBNgł͂Ȃ
	}
	
	// fBNg
	return true;
}

//-----------------------------------------------------
// ֐ : Jiro_GetFileSize
// @\ : t@CTCY擾
//-----------------------------------------------------
long Jiro_GetFileSize( const char* inFilePath )
{
	FILE*	fp;
	fpos_t	dataLength;

	// Ytt@C̃TCY擾
	fp = fopen( inFilePath, "rb" );
	if( fp == NULL )
	{
		return -1;
	}
	fseek( fp, 0, SEEK_END );
	fgetpos( fp, &dataLength );
	fclose( fp );

	return (long)dataLength;
}

//-----------------------------------------------------
// ֐ : Jiro_IsValidFile
// @\ : Lȃt@C
// Ԓl : true	... Ȃ
//        false	... t@C
//-----------------------------------------------------
bool Jiro_IsValidFile( const char * inFilePath, long inMaxSize )
{
	long	filePathLength;

	filePathLength = (long)strlen( inFilePath );
	if( inMaxSize < filePathLength )
	{
		return false;
	}

	return true;	// t@C݂
}

//-----------------------------------------------------
// ֐ : Jiro_GenerateUniqueFilePath
// @\ : j[Nȃt@CpX𐶐
//  : inDirectory ̍Ōɂ'/'Ȃ
// add_hisa, takaesu 071105
//-----------------------------------------------------
void Jiro_GenerateUniqueFilePath( const char* inDirectory, const char* inFineName, const char* inExt, char* outUniqueFilePath )
{
	char	filePath[512] = {0};
	short	uniaueNumber = 0;	// ǉ郆j[Nԍ
	
	// j[Nȃt@CɂȂ܂Ń[v
	sprintf( filePath, "%s\\%s.%s", inDirectory, inFineName, inExt );	
	while( Jiro_IsFileExists( filePath ) == true )
	{
		// j[Nԍ𑫂@
		uniaueNumber = uniaueNumber + 1;
	
		// Ƀj[Nԍ
		memset( filePath, 0, sizeof( filePath ) );
		sprintf( filePath, "%s\\%s-%d.%s", inDirectory, inFineName, uniaueNumber, inExt );
	}

	// j[NȃpXԂ
	strcpy( outUniqueFilePath, filePath );
}

//-----------------------------------------------------
// ֐ : Jiro_IsBinaryFile
// @\ : oCit@CH
//-----------------------------------------------------
long Jiro_IsBinaryFile( const char* inFilePath )
{
	FILE*	fp;
	long 	c;

	// oCi[hŃt@CJ
	fp = fopen( inFilePath, "rb" );
	if( fp == NULL )
	{
		return kFopen_Error;
	}

	// dne܂
	while( feof( fp ) == 0 )
	{
		c = fgetc( fp );
		if( EOF == c )
		{
			break;	// dne
		}
		// AXL[R[hOWȉiOO͗OjH
		else if( 0 != c && c <= 8 )
		{
			fclose( fp );
			return kBinaryFile;	// oCit@C
		}
	}
	fclose( fp );

	return 0;	// eLXgt@C
}

//-----------------------------------------------------
// ֐ : Jiro_SystemErrorLog
// @\ : Ot@CAvP[Vɏo͂
//-----------------------------------------------------
void Jiro_SystemErrorLog( char* inFormat, ... )
{
	FILE*		fp;
	va_list 	vaList;
 	char		appFolderPath[ MAX_PATH ] = {0};
 	char		fullPath[ MAX_PATH ] = {0};
	time_t		timer;
	struct tm*	timePtr;
	char		timeStr[ 128 ] = {0};
	char		msg[65535] = {0};
	
	// fXNgbṽpX擾
	Jiro_GetAppDirectoryPath( appFolderPath );
	
	// tmhwpXɕϊĂAt@CJ
	sprintf( fullPath, "%s%s", appFolderPath, "system_log.txt" );
	fp = fopen( fullPath, "a" );
	if( fp == NULL )
	{
		return;
	}
	
	// tƎԂ擾Ao
	time( &timer );
	timePtr = localtime( &timer );
	if( timePtr != NULL )
	{
		sprintf( timeStr, " %04d/%02d/%02d %02d:%02d:%02d	"
					, timePtr->tm_year+1900, timePtr->tm_mon+1, timePtr->tm_mday
					, timePtr->tm_hour, timePtr->tm_min, timePtr->tm_sec );	
		fprintf( fp, timeStr );
	}
	
	// bZ[Wo
	va_start( vaList, inFormat );
	vsprintf( msg, inFormat, vaList );
	fprintf( fp, msg );
	va_end( vaList );
	
	// t@C	
	fclose( fp );
}

//-----------------------------------------------------
// ֐ : Jiro_WriteBuffer_toFile
// @\ : obt@t@Cɏ
//-----------------------------------------------------
long Jiro_WriteBuffer_toFile( const char* inFilePath, long inBuffSize, const char* inBuff )
{
	FILE *	fp = NULL;
	size_t	witreSize;

	fp = fopen( inFilePath, "w+b" );
	if( fp == NULL )
	{
		return (-1);
	}
	witreSize = fwrite( inBuff, 1, inBuffSize, fp );
	fclose( fp );

	return (long)witreSize;
}

//------------------------------------------------
// ֐ : Jiro_RemoveExtension
// @\ : gq菜
//------------------------------------------------
void Jiro_RemoveExtension( const char* inPath, char* outPath )
{
	long	i, fileLen;

	// gqʂpX𐶐
	fileLen = Jiro_GetIndexOfLastChar( inPath, '.' );
	for( i=0; i<fileLen; i++ )
	{
		outPath[i] = inPath[i];
	}
}

//-----------------------------------------------------
// ֐ F Jiro_DividePath_ToDirectoryAndFileName
// @\ F pXufBNgpXvƁut@Cvɕ
//-----------------------------------------------------
void Jiro_DividePath_ToDirectoryAndFileName( char* inFilePath, char* outDirPath, char* outFileName )
{
	long	pathLen;
	long	fileLen;
	short	i;

	pathLen = (long)strlen( inFilePath );
	fileLen = Jiro_GetIndexOfLastChar( inFilePath, '\\' );

	// t@C쐬
	for( i=0; i<fileLen; i++ )
	{
		outDirPath[i] = inFilePath[i];
	}

	// fBNg쐬
	for( i= 0 ; i < ( pathLen - fileLen ) ; i++ )
	{
		outFileName[i] = inFilePath[ i + fileLen + 1 ];
	}
}

#if _MSC_VER >= 1300
//-----------------------------------------------------
// ֐ : Jiro_GetProgramFilesPath
// @\ : vOt@CYpX擾
//-----------------------------------------------------
void Jiro_GetProgramFilesPath( char* outDesktopPath )
{
	char	desktopPath[ MAX_PATH ] = {0};

	// fXNgbṽpX擾
	SHGetSpecialFolderPath( NULL, (LPSTR)desktopPath, CSIDL_PROGRAM_FILES, FALSE );
	sprintf( outDesktopPath, "%s\\", desktopPath );
}
#endif

//-----------------------------------------------------
// ֐ : Jiro_MakeFindFilter
// @\ : tB^[쐬
//-----------------------------------------------------
void Jiro_MakeFindFilter( const char* inDirPath, char* outFindFilter )
{
	size_t	len;

	// tB^[p^[쐬
	len = strlen( inDirPath );
	if( inDirPath[ len-1 ] == '\\' )
	{
		// \iQoCgڂjH
		if( Jiro_GetCharAttr( (unsigned char*)inDirPath, len-1 ) == 2 )
		{
			sprintf( outFindFilter, "%s\\*.*", inDirPath );
		}
		else
		{
			sprintf( outFindFilter, "%s*.*", inDirPath );
		}
	}
	else
	{
		sprintf( outFindFilter, "%s\\*.*", inDirPath );
	}
}


//-----------------------------------------------------
// ֐ : Jiro_GetFolderPath
// @\ : t@CpXtH_pX؂o
// mod_hisa 120626 mtkkI[ʒuC
//-----------------------------------------------------
void Jiro_GetFolderPath( const char* inFilePath, bool inIsEndSeparator, char* outFolderPath )
{
	long	folderPathLen;
	short	i;

	// 납灏T
	folderPathLen = Jiro_GetIndexOfLastChar( inFilePath, '\\' );

	// Zp[^ij𖖔ɂH
	if( inIsEndSeparator == true )
	{
		folderPathLen = folderPathLen + 1;	// Ɂt
	}

	// tH_pXϐɊi[
	for( i=0; i<folderPathLen; i++ )
	{
		outFolderPath[i] = inFilePath[i];
	}
	outFolderPath[ folderPathLen ] = '\0';	// mtkkI[
}

